Index: /code/branches/core6/src/libraries/core/CorePrereqs.h
===================================================================
--- /code/branches/core6/src/libraries/core/CorePrereqs.h	(revision 9584)
+++ /code/branches/core6/src/libraries/core/CorePrereqs.h	(revision 9585)
@@ -181,4 +181,5 @@
     class OgreWindowEventListener;
     class OrxonoxClass;
+    class OrxonoxInterface;
     class PathConfig;
     struct ResourceInfo;
Index: /code/branches/core6/src/libraries/core/class/OrxonoxClass.h
===================================================================
--- /code/branches/core6/src/libraries/core/class/OrxonoxClass.h	(revision 9584)
+++ /code/branches/core6/src/libraries/core/class/OrxonoxClass.h	(revision 9585)
@@ -35,5 +35,5 @@
     @file
     @ingroup Class OrxonoxClass
-    @brief Declaration of OrxonoxClass, the base class of all objects and interfaces in Orxonox.
+    @brief Declaration of OrxonoxClass, the base class of all objects in Orxonox.
 */
 
@@ -49,7 +49,7 @@
 {
     /**
-        @brief This is the class from which all objects and interfaces of the game-logic (not the engine) are derived from.
+        @brief This is the class from which all objects of the game-logic (not the engine) are derived from.
 
-        The BaseObject and Interfaces are derived with @c virtual @c public @c OrxonoxClass from OrxonoxClass.
+        The BaseObject and other classes are derived with @c virtual @c public @c OrxonoxClass from OrxonoxClass.
     */
     class _CoreExport OrxonoxClass : virtual public Configurable, virtual public Destroyable
Index: /code/branches/core6/src/libraries/core/class/OrxonoxInterface.h
===================================================================
--- /code/branches/core6/src/libraries/core/class/OrxonoxInterface.h	(revision 9585)
+++ /code/branches/core6/src/libraries/core/class/OrxonoxInterface.h	(revision 9585)
@@ -0,0 +1,55 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @ingroup Class OrxonoxClass
+    @brief Declaration of OrxonoxInterface, the base class of all interfaces in Orxonox.
+*/
+
+#ifndef _OrxonoxInterface_H__
+#define _OrxonoxInterface_H__
+
+#include "core/CorePrereqs.h"
+
+#include "core/config/Configurable.h"
+#include "core/object/Destroyable.h"
+
+namespace orxonox
+{
+    /**
+        @brief This is the class from which all interfaces of the game-logic (not the engine) are derived from.
+
+        Interfaces are derived with @c virtual @c public @c OrxonoxInterface from OrxonoxInterface.
+    */
+    class _CoreExport OrxonoxInterface : virtual public Configurable, virtual public Destroyable
+    {
+    };
+}
+
+#endif /* _OrxonoxInterface_H__ */
Index: /code/branches/core6/src/modules/weapons/projectiles/BasicProjectile.h
===================================================================
--- /code/branches/core6/src/modules/weapons/projectiles/BasicProjectile.h	(revision 9584)
+++ /code/branches/core6/src/modules/weapons/projectiles/BasicProjectile.h	(revision 9585)
@@ -39,5 +39,5 @@
 #include "worldentities/pawns/Pawn.h"
 
-#include "core/class/OrxonoxClass.h"
+#include "core/class/OrxonoxInterface.h"
 
 namespace orxonox
@@ -52,5 +52,5 @@
     @ingroup WeaponsProjectiles
     */
-    class _WeaponsExport BasicProjectile : public virtual OrxonoxClass
+    class _WeaponsExport BasicProjectile : public virtual OrxonoxInterface
     {
         public:
Index: /code/branches/core6/src/orxonox/LevelInfo.h
===================================================================
--- /code/branches/core6/src/orxonox/LevelInfo.h	(revision 9584)
+++ /code/branches/core6/src/orxonox/LevelInfo.h	(revision 9585)
@@ -45,5 +45,5 @@
 #include <iostream>
 #include <fstream>
-#include "core/class/OrxonoxClass.h"
+#include "core/class/OrxonoxInterface.h"
 
 namespace orxonox // tolua_export
@@ -61,5 +61,5 @@
     */
     class _OrxonoxExport LevelInfoItem // tolua_export
-        : virtual public OrxonoxClass
+        : virtual public OrxonoxInterface
     { // tolua_export
         public:
Index: /code/branches/core6/src/orxonox/MoodManager.h
===================================================================
--- /code/branches/core6/src/orxonox/MoodManager.h	(revision 9584)
+++ /code/branches/core6/src/orxonox/MoodManager.h	(revision 9585)
@@ -34,5 +34,5 @@
 #include <string>
 #include "util/Singleton.h"
-#include "core/config/Configurable.h"
+#include "core/class/OrxonoxInterface.h"
 
 namespace orxonox
@@ -42,5 +42,5 @@
         The MoodListener class is aware of a change in themes and directs that info to dependent classes.
     */
-    class _OrxonoxExport MoodListener : virtual public OrxonoxClass
+    class _OrxonoxExport MoodListener : virtual public OrxonoxInterface
     {
         friend class MoodManager;
Index: /code/branches/core6/src/orxonox/interfaces/GametypeMessageListener.h
===================================================================
--- /code/branches/core6/src/orxonox/interfaces/GametypeMessageListener.h	(revision 9584)
+++ /code/branches/core6/src/orxonox/interfaces/GametypeMessageListener.h	(revision 9585)
@@ -31,9 +31,9 @@
 
 #include "OrxonoxPrereqs.h"
-#include "core/class/OrxonoxClass.h"
+#include "core/class/OrxonoxInterface.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport GametypeMessageListener : virtual public OrxonoxClass
+    class _OrxonoxExport GametypeMessageListener : virtual public OrxonoxInterface
     {
         public:
Index: /code/branches/core6/src/orxonox/interfaces/NotificationListener.h
===================================================================
--- /code/branches/core6/src/orxonox/interfaces/NotificationListener.h	(revision 9584)
+++ /code/branches/core6/src/orxonox/interfaces/NotificationListener.h	(revision 9585)
@@ -44,5 +44,5 @@
 #include "util/StringUtils.h"
 
-#include "core/class/OrxonoxClass.h"
+#include "core/class/OrxonoxInterface.h"
 
 namespace orxonox
@@ -90,5 +90,5 @@
     @todo Consistent terminology between message, notification and command.
     */
-    class _OrxonoxExport NotificationListener : virtual public OrxonoxClass
+    class _OrxonoxExport NotificationListener : virtual public OrxonoxInterface
     {
         public:
Index: /code/branches/core6/src/orxonox/interfaces/PickupCarrier.h
===================================================================
--- /code/branches/core6/src/orxonox/interfaces/PickupCarrier.h	(revision 9584)
+++ /code/branches/core6/src/orxonox/interfaces/PickupCarrier.h	(revision 9585)
@@ -41,5 +41,5 @@
 #include <vector>
 
-#include "core/class/OrxonoxClass.h"
+#include "core/class/OrxonoxInterface.h"
 
 namespace orxonox
@@ -66,5 +66,5 @@
     @ingroup Pickup
     */
-    class _OrxonoxExport PickupCarrier : virtual public OrxonoxClass
+    class _OrxonoxExport PickupCarrier : virtual public OrxonoxInterface
     {
         // So that the different Pickupables have full access to their PickupCarrier.
Index: /code/branches/core6/src/orxonox/interfaces/PickupListener.h
===================================================================
--- /code/branches/core6/src/orxonox/interfaces/PickupListener.h	(revision 9584)
+++ /code/branches/core6/src/orxonox/interfaces/PickupListener.h	(revision 9585)
@@ -39,5 +39,5 @@
 #include "Pickupable.h"
 
-#include "core/class/OrxonoxClass.h"
+#include "core/class/OrxonoxInterface.h"
 
 namespace orxonox
@@ -55,5 +55,5 @@
     @ingroup Pickup
     */
-    class _OrxonoxExport PickupListener : virtual public OrxonoxClass
+    class _OrxonoxExport PickupListener : virtual public OrxonoxInterface
     {
         public:
Index: /code/branches/core6/src/orxonox/interfaces/Pickupable.h
===================================================================
--- /code/branches/core6/src/orxonox/interfaces/Pickupable.h	(revision 9584)
+++ /code/branches/core6/src/orxonox/interfaces/Pickupable.h	(revision 9585)
@@ -41,5 +41,5 @@
 #include "core/class/Super.h"
 
-#include "core/class/OrxonoxClass.h"
+#include "core/class/OrxonoxInterface.h"
 #include "Rewardable.h"
 
@@ -58,5 +58,5 @@
     @ingroup Pickup
     */
-    class _OrxonoxExport Pickupable : virtual public OrxonoxClass, public Rewardable
+    class _OrxonoxExport Pickupable : virtual public OrxonoxInterface, public Rewardable
     {
         friend class PickupCarrier;
Index: /code/branches/core6/src/orxonox/interfaces/PlayerTrigger.h
===================================================================
--- /code/branches/core6/src/orxonox/interfaces/PlayerTrigger.h	(revision 9584)
+++ /code/branches/core6/src/orxonox/interfaces/PlayerTrigger.h	(revision 9585)
@@ -38,5 +38,5 @@
 #include "OrxonoxPrereqs.h"
 
-#include "core/class/OrxonoxClass.h"
+#include "core/class/OrxonoxInterface.h"
 #include "core/object/WeakPtr.h"
 
@@ -52,5 +52,5 @@
     @ingroup Triggers
     */
-    class _OrxonoxExport PlayerTrigger : virtual public OrxonoxClass
+    class _OrxonoxExport PlayerTrigger : virtual public OrxonoxInterface
     {
     public:
Index: /code/branches/core6/src/orxonox/interfaces/RadarListener.h
===================================================================
--- /code/branches/core6/src/orxonox/interfaces/RadarListener.h	(revision 9584)
+++ /code/branches/core6/src/orxonox/interfaces/RadarListener.h	(revision 9585)
@@ -31,9 +31,9 @@
 
 #include "OrxonoxPrereqs.h"
-#include "core/class/OrxonoxClass.h"
+#include "core/class/OrxonoxInterface.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport RadarListener : virtual public OrxonoxClass
+    class _OrxonoxExport RadarListener : virtual public OrxonoxInterface
     {
     public:
Index: /code/branches/core6/src/orxonox/interfaces/RadarViewable.h
===================================================================
--- /code/branches/core6/src/orxonox/interfaces/RadarViewable.h	(revision 9584)
+++ /code/branches/core6/src/orxonox/interfaces/RadarViewable.h	(revision 9585)
@@ -36,5 +36,5 @@
 
 #include "util/Math.h"
-#include "core/class/OrxonoxClass.h"
+#include "core/class/OrxonoxInterface.h"
 #include "core/object/SmartPtr.h"
 
@@ -46,5 +46,5 @@
     @brief Interface for receiving window events.
     */
-    class _OrxonoxExport RadarViewable : virtual public OrxonoxClass
+    class _OrxonoxExport RadarViewable : virtual public OrxonoxInterface
     {
     public:
Index: /code/branches/core6/src/orxonox/interfaces/Rewardable.h
===================================================================
--- /code/branches/core6/src/orxonox/interfaces/Rewardable.h	(revision 9584)
+++ /code/branches/core6/src/orxonox/interfaces/Rewardable.h	(revision 9585)
@@ -36,5 +36,5 @@
 
 #include "OrxonoxPrereqs.h"
-#include "core/class/OrxonoxClass.h"
+#include "core/class/OrxonoxInterface.h"
 
 namespace orxonox
@@ -48,5 +48,5 @@
         Damian 'Mozork' Frick
     */
-    class _OrxonoxExport Rewardable : virtual public OrxonoxClass
+    class _OrxonoxExport Rewardable : virtual public OrxonoxInterface
     {
         public:
Index: /code/branches/core6/src/orxonox/interfaces/TeamColourable.h
===================================================================
--- /code/branches/core6/src/orxonox/interfaces/TeamColourable.h	(revision 9584)
+++ /code/branches/core6/src/orxonox/interfaces/TeamColourable.h	(revision 9585)
@@ -33,9 +33,9 @@
 
 #include "util/UtilPrereqs.h"
-#include "core/class/OrxonoxClass.h"
+#include "core/class/OrxonoxInterface.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport TeamColourable : virtual public OrxonoxClass
+    class _OrxonoxExport TeamColourable : virtual public OrxonoxInterface
     {
         public: