Index: /code/branches/core6/src/libraries/core/object/CMakeLists.txt
===================================================================
--- /code/branches/core6/src/libraries/core/object/CMakeLists.txt	(revision 9590)
+++ /code/branches/core6/src/libraries/core/object/CMakeLists.txt	(revision 9591)
@@ -1,5 +1,4 @@
 ADD_SOURCE_FILES(CORE_SRC_FILES
   Context.cc
-  ContextObject.cc
   Destroyable.cc
   Listable.cc
Index: /code/branches/core6/src/libraries/core/object/Context.cc
===================================================================
--- /code/branches/core6/src/libraries/core/object/Context.cc	(revision 9590)
+++ /code/branches/core6/src/libraries/core/object/Context.cc	(revision 9591)
@@ -33,11 +33,9 @@
 
 #include "Context.h"
-#include "core/CoreIncludes.h"
 
 namespace orxonox
 {
-    Context::Context(Context* context) : ContextObject(this), parentContext_(context)
+    Context::Context(Context* context) : parentContext_(context)
     {
-        RegisterRootObject(Context);
     }
 
Index: /code/branches/core6/src/libraries/core/object/Context.h
===================================================================
--- /code/branches/core6/src/libraries/core/object/Context.h	(revision 9590)
+++ /code/branches/core6/src/libraries/core/object/Context.h	(revision 9591)
@@ -37,9 +37,7 @@
 #include "core/CorePrereqs.h"
 
-#include "ContextObject.h"
-
 namespace orxonox
 {
-    class _CoreExport Context : public ContextObject
+    class _CoreExport Context
     {
         public:
Index: de/branches/core6/src/libraries/core/object/ContextObject.cc
===================================================================
--- /code/branches/core6/src/libraries/core/object/ContextObject.cc	(revision 9590)
+++ 	(revision )
@@ -1,50 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Fabian 'x3n' Landau
- *   Co-authors:
- *      ...
- *
- */
-
-/**
-    @file
-    @brief Implementation of ContextObject.
-*/
-
-#include "ContextObject.h"
-
-#include <cassert>
-#include "core/CoreIncludes.h"
-#include "Context.h"
-
-namespace orxonox
-{
-    ContextObject::ContextObject(Context* context) : context_(context)
-    {
-        RegisterRootObject(ContextObject);
-
-        //assert(context);
-        if (!this->context_)
-            this->context_ = Context::getRootContext();
-    }
-}
Index: de/branches/core6/src/libraries/core/object/ContextObject.h
===================================================================
--- /code/branches/core6/src/libraries/core/object/ContextObject.h	(revision 9590)
+++ 	(revision )
@@ -1,56 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Fabian 'x3n' Landau
- *   Co-authors:
- *      ...
- *
- */
-
-/**
-    @file
-    @ingroup Object
-*/
-
-#ifndef _ContextObject_H__
-#define _ContextObject_H__
-
-#include "core/CorePrereqs.h"
-
-#include "core/class/OrxonoxClass.h"
-
-namespace orxonox
-{
-    class _CoreExport ContextObject : virtual public OrxonoxClass
-    {
-        public:
-            ContextObject(Context* context);
-
-            /// Returns the object's Context.
-            inline Context* getContext() const { return this->context_; }
-
-        private:
-            Context* context_; //!< The object's context
-    };
-}
-
-#endif /* _ContextObject_H__ */